const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const ai_outputs = sequelize.define(
    'ai_outputs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

visibility: {
        type: DataTypes.ENUM,
      
      

        values: [

"private",


"public_projection",


"admin_only"

        ],

      },

output_title: {
        type: DataTypes.TEXT,
      
      

      },

output_text: {
        type: DataTypes.TEXT,
      
      

      },

generated_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  ai_outputs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.ai_outputs.belongsTo(db.ai_requests, {
      as: 'ai_request',
      foreignKey: {
        name: 'ai_requestId',
      },
      constraints: false,
    });

    db.ai_outputs.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.ai_outputs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.ai_outputs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return ai_outputs;
};


